//保存base 64 字符，提供上传
var testJson = {'imgList':[]};
var i=1,gentry=null,w=null;
var hl=null,le=null,de=null; 

var f1=null;
var f2=null;

// 监听DOMContentLoaded事件,它在DOM加载之后及资源加载之前被触发.
document.addEventListener("DOMContentLoaded",function(){
	// 获取DOM元素对象
	hl=document.getElementById("history"); 
	le=document.getElementById("empty");
},false );

// 拍照
function getImage() {
	var cmr = plus.camera.getCamera(); 
	cmr.captureImage( function ( p ) {
	plus.io.resolveLocalFileSystemURL( p, function ( entry ) {
		//转化本地绝对路径
		var urlHope = plus.io.convertLocalFileSystemURL(p);
		if(testJson.imgList.length < 5){
			appendFile(urlHope);
	    }
	});  
	},function( error ) {
			console.log("---"+"Capture image failed: " + error.message);
		},{}   //建议使用系统匹配路径
	);
}

// 从相册选择图片，imageId:图片列表标志
function appendByGallery(){
	plus.gallery.pick(function(path){
		for(var i in path.files){
			if(testJson.imgList.length < 5) {
		    	appendFile(path.files[i]); //显示
			}else {
				break;
			}
    	}
    },function(error) {
//  	alert( "Capture image failed: " + error.message );
    },{filename:"file:///storage/sdcard0/DCIM/Camera/"+"ra/",multiple:true,maximum:5-Number($("#imageCount").html()),system:false});
}


// 图片压缩显示,成功回调函数
var index = 0;
function appendFile(path){
	plus.nativeUI.showWaiting("加载中......");
	//图片方向
	var Orientation;
  	var img = new Image();
    img.src = path;
    img.onload = function () {
        var that = this;
        //生成比例 
        var w = that.width,
        h = that.height,
        scale = w / h; 
        w = 480 || w;  //480  你想压缩到多大
        h = w / scale;
        //生成canvas
        var canvas = document.createElement('canvas');
        
        var ctx = canvas.getContext('2d');
        
        $(canvas).attr({width : w, height : h});
        //获取照片方向角属性，用户旋转控制 ,判断当前图片是否需要做旋转操作。
	    EXIF.getData(img, function() {
	        EXIF.getAllTags(this);   
	        /**
	         * 图片的旋转方向信息
	         * 1、图片没有发生旋转
	         * 6、顺时针90°
	         * 8、逆时针90°
	         * 3、180° 旋转
	         */
	        Orientation = EXIF.getTag(this, 'Orientation');
		    if(Orientation != "" && Orientation != null) {
		    	// 方向信息，canvas 显示形式，canvas 对象，that,宽度，高度
		    	rotateImg(Orientation,ctx,canvas,that,w,h);
		    }else {
		    	rotateImg(Orientation,ctx,canvas,that,w,h);
		    }
	    });

    }
}

// 图片旋转操作
function rotateImg(Orientation,ctx,canvas,that,w,h) {
	if(Orientation == "6") {
		$(canvas).attr({width : w/2, height : h});
    	ctx.translate(270, 0);
	    var angle = 90;
	    //清空画布指定像素
	    ctx.clearRect(-w, -h, w, h); 
	    // 画布旋转 90度
		ctx.rotate(angle * Math.PI / 180);
		ctx.fillRect(w, h, w, h);
    }
	//向画布上绘制图像、画布或视频
    ctx.drawImage(that, 0, 0, w, h);

    var base64 = canvas.toDataURL('image/jpeg', 1 || 0.8 );   //1z 表示图片质量，越低越模糊。
	index++;
	testJson.imgList.push({base64String:base64}); //保存base64 到数组
   	
   	var statusDoc1 = document.getElementById("bor1").style.display;
	var statusDoc2 = document.getElementById("bor2").style.display;
	var statusDoc3 = document.getElementById("bor3").style.display;
	var statusDoc4 = document.getElementById("bor4").style.display;
	var statusDoc5 = document.getElementById("bor5").style.display;
    if(statusDoc1 == "none") {
		$("#bor1").css("display","block"); //图片状态
	   	var pic = document.getElementById("img1");    
		pic.src = base64; //这里丢到img 的 src 里面就能看到效果了
		plus.nativeUI.closeWaiting();
    }else if(statusDoc2 == "none") {
    	$("#bor2").css("display","block");
	   	var pic = document.getElementById("img2");    
		pic.src = base64;
		plus.nativeUI.closeWaiting();
    }else if(statusDoc3 == "none") {
    	$("#bor3").css("display","block");
	   	var pic = document.getElementById("img3");    
		pic.src = base64;
		plus.nativeUI.closeWaiting();
    }else if(statusDoc4 == "none") {
    	$("#bor4").css("display","block");
	   	var pic = document.getElementById("img4");    
		pic.src = base64;
		plus.nativeUI.closeWaiting();
    }else if(statusDoc5 == "none") {
    	$("#bor5").css("display","block");
	   	var pic = document.getElementById("img5");    
		pic.src = base64;
		plus.nativeUI.closeWaiting();
    }
    $("#imageCount").html(testJson.imgList.length);
    if(testJson.imgList.length >= 5) {
    	$("#bor6").hide();
    }
    console.log(JSON.stringify(testJson.imgList));
}


/**
 * 删除图片，指定移出图片在base64 字符数组中对应的位置
 */
function removeHope(index) {
	testJson.imgList.splice(index-1,1);
	$("#img"+index+"").attr("src","");
	$("#bor"+index+"").css("display","none");
	$("#imageCount").html(Number($("#imageCount").html()) - 1);
	$("#bor6").show();
}


